t_1 = paste0(c("y = ", as.vector(signif(coef(lin_1),digits=3)), " x, R² = ", signif(summary(lin_1)$adj.r.squared,digits=2)), collapse="")
t_2 = paste0(c("y = ", as.vector(signif(coef(lin_2),digits=3)), " x, R² = ", signif(summary(lin_2)$adj.r.squared,digits=2)), collapse="")
t_3 = paste0(c("y = ", as.vector(signif(coef(lin_3),digits=3)), " x, R² = ", signif(summary(lin_3)$adj.r.squared,digits=2)), collapse="")
t_4 = paste0(c("y = ", as.vector(signif(coef(lin_4),digits=3)), " x, R² = ", signif(summary(lin_4)$adj.r.squared,digits=2)), collapse="")
t_all = paste0(c("y = ", as.vector(signif(coef(lin_all),digits=3)), " x, R = ", signif(summary(lin_all)$adj.r.squared,digits=2)), collapse="")

pdf(file=file.path(basepath,"churn.pdf"), width=9, height=4.5)
par(mai=c(0.8, 0.8, 0.1, 0.5))
plot(churn_1$norm_faults ~ churn_1$norm_mods, pch = 4, col = "red", xlab = "Churn per day", ylab="New faults per day",xlim=c(0,400),ylim=c(0,2))
par(new=TRUE)
plot(churn_2$norm_faults ~ churn_2$norm_mods, pch = 1, col = "orange", xaxt='n', yaxt='n',xlim=c(0,400),ylim=c(0,2),xlab="",ylab="")
par(new=TRUE)
plot(churn_3$norm_faults ~ churn_3$norm_mods, pch = 0, col = "blue", xaxt='n', yaxt='n',xlim=c(0,400),ylim=c(0,2),xlab="",ylab="")
par(new=TRUE)
plot(churn_4$norm_faults ~ churn_4$norm_mods, pch = 2, col = "darkgreen", xaxt='n', yaxt='n',xlim=c(0,400),ylim=c(0,2),xlab="",ylab="")
abline(lin_1, col = "red")
abline(lin_2, col = "orange")
abline(lin_3, col = "blue")
abline(lin_4, col = "darkgreen")
abline(lin_all, col = "black")
grid(col="gray50")
legend(0,2,legend=c("Linux 2.6.1 to 2.6.10","Linux 2.6.11 to 2.6.20","Linux 2.6.21 to 2.6.30","Linux 2.6.31 to 3.0","Linux 2.6.1 to 3.0"),col=c("red", "orange","blue","darkgreen","black"), pch=c(4,1,0,2,-1),lty=1,bg="white")
legend(265,.75,legend=c(t_1,t_2,t_3,t_4,t_all),col=c("red", "orange","blue","darkgreen","black"), lty=1,bg="white")
dev.off()

xlog = 10 * 1:41
logm = lm(exp(churn_all$norm_faults) ~ churn_all$norm_mods)
#yloghat0 = predict(logm)
#yloghat = as.vector(log(yloghat0))
yloghat =  log(coef(logm)[1] + coef(logm)[2]*xlog)

xexp = 10 * -1:41
expm =  lm(log(churn_all$norm_faults) ~ churn_all$norm_mods)
yexphat = exp(coef(expm)[1]) * exp(coef(expm)[2]*xexp)

pdf(file=file.path(basepath,"churn-reg.pdf"), width=9, height=4.5)
par(mai=c(0.8, 0.8, 0.1, 0.5))
plot(churn_1$norm_faults ~ churn_1$norm_mods, pch = 4, col = "red", xlab = "Churn per day", ylab="New faults per day",xlim=c(0,400),ylim=c(0,2))
par(new=TRUE)
plot(churn_2$norm_faults ~ churn_2$norm_mods, pch = 1, col = "orange", xaxt='n', yaxt='n',xlim=c(0,400),ylim=c(0,2),xlab="",ylab="")
par(new=TRUE)
plot(churn_3$norm_faults ~ churn_3$norm_mods, pch = 0, col = "blue", xaxt='n', yaxt='n',xlim=c(0,400),ylim=c(0,2),xlab="",ylab="")
par(new=TRUE)
plot(churn_4$norm_faults ~ churn_4$norm_mods, pch = 2, col = "darkgreen", xaxt='n', yaxt='n',xlim=c(0,400),ylim=c(0,2),xlab="",ylab="")
abline(lin_all, col = "black")
par(new=TRUE)
#plot(sort(yloghat) ~ sort(churn_all$norm_mods), type="l", lty=2, col="black", xaxt='n', yaxt='n',xlim=c(0,400),ylim=c(0,2),xlab="",ylab="")
plot(sort(yloghat) ~ xlog, type="l", lty=2, col="black", xaxt='n', yaxt='n',xlim=c(0,400),ylim=c(0,2),xlab="",ylab="")
par(new=TRUE)
#plot(sort(yexphat) ~ sort(churn_all$norm_mods), type="l", lty=3, col="black", xaxt='n', yaxt='n',xlim=c(0,400),ylim=c(0,2),xlab="",ylab="")
plot(yexphat ~ xexp, type="l", lty=3, col="black", xaxt='n', yaxt='n',xlim=c(0,400),ylim=c(0,2),xlab="",ylab="")
grid(col="gray50")
legend(0,2,
	legend=c("Linux 2.6.1 to 2.6.10","Linux 2.6.11 to 2.6.20","Linux 2.6.21 to 2.6.30","Linux 2.6.31 to 3.0","Linear", "Log","Exp"),
	col=c("red", "orange","blue","darkgreen",rep("black",3)),	pch=c(4,1,0,2,rep(-1,3)),	lty=c(rep(1,5),2,3), bg="white")
dev.off()

