
pdf(file=file.path(basepath,"lifespan-right.pdf"), width=9, height=4.5)
par(mai=c(0.8, 0.8, 0.1, 0.5),bty="n",lab=c(10,10,7))
plot(bug_lifes_no_left.fit_rcensoring_1,xscale=365.25, xlab = "Years", ylab="Survival rate", xlim=c(0,8))
grid(col="gray50")
dev.off()

pdf(file=file.path(basepath,"lifespan-improvement-right.pdf"), width=9, height=4.5)
par(mai=c(0.8, 0.8, 0.1, 0.5),bty="n",lab=c(10,10,7))
plot(bug_lifes_no_left.fit_rcensoring_ntile,xscale=365.25, xlab = "Years", ylab="Survival rate", col=c("black", "black"), lty=1:2, xlim=c(0,8))
grid(col="gray50")
legend(.5,.2,legend=c("1st half","2nd half"),col=c("black", "black"), lty=1:2,bg="white")
dev.off()

pdf(file=file.path(basepath,"lifespan-improvement-interval2.pdf"), width=9, height=4.5)
par(mai=c(0.8, 0.8, 0.1, 0.5),bty="n",lab=c(10,10,7))
plot(bug_lifes_w_NA.fit_ntile,xscale=365.25, xlab = "Years", ylab="Survival rate", col=c("black", "black"), lty=1:2, xlim=c(0,8))
grid(col="gray50")
legend(.5,.2,legend=c("1st half","2nd half"),bg="white",col=c("black", "black"), lty=1:2)
dev.off()

pdf(file=file.path(basepath,"lifespan-dir-right.pdf"), width=9, height=4.5)
par(mai=c(0.8, 0.8, 0.1, 0.5),bty="n",lab=c(10,10,7))
plot(bug_lifes_no_left.fit_rcensoring_dir,xscale=365.25, xlab = "Years", ylab="Survival rate", lty=1:6, xlim=c(0,8),
col=c("blue","red","cyan","green","orange","pink"))
grid(col="gray50")
legend(5,.8,legend=c("sound","drivers", "arch", "fs","net", "other"), lty=1:6,bg="white",
col=c("blue","red","cyan","green","orange","pink"))
dev.off()

pdf(file=file.path(basepath,"lifespan-cat-right.pdf"), width=9, height=4.5)
par(mai=c(0.8, 0.8, 0.1, 0.5),bty="n",lab=c(10,10,7))
plot(bug_lifes_no_left.fit_rcensoring_cat,xscale=365.25, xlab = "Years", ylab="Survival rate", lty=1:6, xlim=c(0,8),
col=c("green","blue","red","green","brown","orange"))
grid(col="gray50")
legend(5,.8,legend=c("EEL","EEH", "EHL", "EHH","HEH", "HHL"), lty=1:6,bg="white",
col=c("green","blue","red","green","brown","orange"))
dev.off()

#############

pdf(file=file.path(basepath,"lifespan-min-max.pdf"), width=9, height=4.5)
par(mai=c(0.8, 0.8, 0.1, 0.5),bty="n",lab=c(10,10,7))
plot(bug_lifes_no_left.fit_rcensoring_1,xscale=365.25, xlab = "Years", ylab="Survival rate",
	xlim=c(0,10),col=rep('black',3),conf.int=FALSE)
par(lab=c(10,10,7), new=TRUE)
plot(bug_lifes_w_NA.fit_min,xscale=365.25, xlim=c(0,10), col=rep('darkgreen',3),conf.int=FALSE, xaxt='n', yaxt='n')
par(lab=c(10,10,7), new=TRUE)
plot(bug_lifes_w_NA.fit_max,xscale=365.25, xlim=c(0,10), col=rep('red',3), xaxt='n', yaxt='n')
par(lab=c(10,10,7), new=TRUE)
plot(bug_lifes_w_NA.fit_med,xscale=365.25, xlim=c(0,10), col=rep('black',3),lty=3,conf.int=FALSE, xaxt='n', yaxt='n')
grid(col="gray50")
legend(5,.8,legend=c("Max","Median","Min","No 2.6.0"), lty=c(1,3,1,1),bg="white",
col=c("red","black","darkgreen","black"))
dev.off()


# quartz(width=9, height=4.5) # dev.new(width=9, height=4.5)
