basepath = "/Users/npalix/Documents/Papers/papers.diku/atocs/experiments/tools/R/"

# Load data
bug_lifes_no_left <- dbGetQuery(con,
"select name_ranking.rank::integer as standardized_name_id, bugs.standardized_name,
	study_dirname_id,
	difficulty, difficulty_id,
	correlation_birth_date,
	correlation_birth_date - origin.date as birth,
	coalesce(correlation_death_date, study_futur_release()) - origin.date as death,
case
 	when correlation_death_date is null then false
 	when correlation_birth_date = origin.date then false
 	else true end as censor,
 	ntile(2) over (order by correlation_birth_date)
from study_helper_considered_bugs_for_lifespan_wo_staging as bugs
join (select rank() over (order by standardized_name), standardized_name from error_names group by standardized_name) name_ranking using (standardized_name)
join study_dirnames using (study_dirname)
JOIN ( VALUES ('Var'::text,'EEL'::text, 1), ('IsNull'::text,'EEL'::text, 1), ('Range'::text,'EEL'::text, 1), ('Lock'::text,'EEH'::text,2), ('Intr'::text,'EEH'::text,2), ('LockIntr'::text,'EEH'::text,2), ('NullRef'::text,'EHL'::text,3), ('Float'::text,'EHH'::text,4), ('Free'::text,'HEH'::text,5), ('BlockLock'::text,'HHL'::text,6), ('BlockIntr'::text,'HHL'::text,6), ('Null'::text,'HHL'::text,6)) a(standardized_name, difficulty, difficulty_id) using (standardized_name),
(select release_date as date from versions where version_name = 'linux-2.6.0') origin
WHERE  correlation_birth_date != origin.date
AND bugs.study_dirname != 'staging' 
ORDER BY correlation_birth_date")

# 3567 days between 1.0 and 2.6.0 (half -> 1783 days) => 1999-01-30 --- (origin.date - (origin.date-genesis.date)/2)
# Minus half of the average of min - 2002-10-09
# Minus the average of min - 2001-07-31
# Minus the average of 'no 2.6.0' - 2001-09-15
# Minus the average of max - 2000-04-16
bug_lifes_w_NA <- dbGetQuery(con,
"select name_ranking.rank::integer as standardized_name_id, bugs.standardized_name,
	study_dirname_id,
	difficulty, difficulty_id,
	correlation_birth_date,
	COALESCE(correlation_death_date, study_futur_release())  - correlation_birth_date as death_lower,
	
	case correlation_birth_date
	when origin.date then correlation_death_date - origin.date
	else correlation_death_date - correlation_birth_date
	end as death_upper_min,
	
	case correlation_birth_date
	when origin.date then correlation_death_date - genesis.date
	else correlation_death_date - correlation_birth_date
	end as death_upper_max,
	
	case correlation_birth_date
	when origin.date then correlation_death_date - '1999-01-30'::date
	else correlation_death_date - correlation_birth_date
	end as death_upper_med,
 	
 	ntile(2) over (order by correlation_birth_date)
from study_helper_considered_bugs_for_lifespan_wo_staging as bugs
join (select rank() over (order by standardized_name), standardized_name from error_names group by standardized_name) name_ranking using (standardized_name)
join study_dirnames using (study_dirname)
JOIN ( VALUES ('Var'::text,'EEL'::text, 1), ('IsNull'::text,'EEL'::text, 1), ('Range'::text,'EEL'::text, 1), ('Lock'::text,'EEH'::text,2), ('Intr'::text,'EEH'::text,2), ('LockIntr'::text,'EEH'::text,2), ('NullRef'::text,'EHL'::text,3), ('Float'::text,'EHH'::text,4), ('Free'::text,'HEH'::text,5), ('BlockLock'::text,'HHL'::text,6), ('BlockIntr'::text,'HHL'::text,6), ('Null'::text,'HHL'::text,6)) a(standardized_name, difficulty, difficulty_id) using (standardized_name),
(select release_date as date from versions where version_name = 'linux-2.6.0') origin,
(select release_date as date from versions where version_name = 'linux-1.0') genesis")

###############
# Survival object
###############
#bug_lifes.surv_rcensoring <- Surv(bug_lifes$death - bug_lifes$birth, bug_lifes$censor,type="right")
bug_lifes_no_left.surv_rcensoring <- Surv(bug_lifes_no_left$death - bug_lifes_no_left$birth, bug_lifes_no_left$censor,type="right")
bug_lifes_w_NA.surv_min <- Surv(bug_lifes_w_NA$death_lower, bug_lifes_w_NA$death_upper_min,type="interval2")
bug_lifes_w_NA.surv_max <- Surv(bug_lifes_w_NA$death_lower, bug_lifes_w_NA$death_upper_max,type="interval2")
bug_lifes_w_NA.surv_med <- Surv(bug_lifes_w_NA$death_lower, bug_lifes_w_NA$death_upper_med,type="interval2")

#bug_lifes.fit_rcensoring_1 <- survfit(bug_lifes.surv_rcensoring~1, data=bug_lifes)
#bug_lifes.fit_rcensoring_ntile <- survfit(bug_lifes.surv_rcensoring~ntile, data=bug_lifes)
bug_lifes_no_left.fit_rcensoring_1 <- survfit(bug_lifes_no_left.surv_rcensoring~1, data=bug_lifes_no_left)
bug_lifes_no_left.fit_rcensoring_ntile <- survfit(bug_lifes_no_left.surv_rcensoring~ntile, data=bug_lifes_no_left)
bug_lifes_no_left.fit_rcensoring_dir <- survfit(bug_lifes_no_left.surv_rcensoring~ study_dirname_id, data=bug_lifes_no_left)
bug_lifes_no_left.fit_rcensoring_cat <- survfit(bug_lifes_no_left.surv_rcensoring~ difficulty_id, data=bug_lifes_no_left)
bug_lifes_w_NA.fit_min  <- survfit(bug_lifes_w_NA.surv_min ~1, data=bug_lifes_w_NA )
bug_lifes_w_NA.fit_max  <- survfit(bug_lifes_w_NA.surv_max ~1, data=bug_lifes_w_NA )
bug_lifes_w_NA.fit_med  <- survfit(bug_lifes_w_NA.surv_med ~1, data=bug_lifes_w_NA )
bug_lifes_w_NA.fit_ntile  <- survfit(bug_lifes_w_NA.surv_med ~ ntile, data=bug_lifes_w_NA )
bug_lifes_w_NA.fit_dir  <- survfit(bug_lifes_w_NA.surv_med ~ study_dirname_id, data=bug_lifes_w_NA )
bug_lifes_w_NA.fit_cat  <- survfit(bug_lifes_w_NA.surv_med ~ difficulty_id, data=bug_lifes_w_NA )

	# Default parameters
	# conf.int=.95,
	# type="kaplan-meier"

# scale = 365.24
# print(bug_lifes.fit_rcensoring_1, print.rmean = TRUE)
# print(bug_lifes.fit_rcensoring_ntile, print.rmean = TRUE)
print(bug_lifes_no_left.fit_rcensoring_1, print.rmean = TRUE, rmean="common")
print(bug_lifes_no_left.fit_rcensoring_1, print.rmean = TRUE, rmean= 2805 , scale=365.24)
print(bug_lifes_no_left.fit_rcensoring_ntile, print.rmean = TRUE, rmean= 2805)
#print(bug_lifes_no_left.fit_rcensoring_dir, print.rmean = TRUE, rmean= 2805 , scale=365.24)
#print(bug_lifes_no_left.fit_rcensoring_cat, print.rmean = TRUE, rmean= 2805 , scale=365.24)
print(bug_lifes_w_NA.fit_min, print.rmean = TRUE, rmean= 2867, scale=365.24)
print(bug_lifes_w_NA.fit_max, print.rmean = TRUE, scale=365.24)
print(bug_lifes_w_NA.fit_med, print.rmean = TRUE, scale=365.24)
#print(bug_lifes_w_NA.fit_ntile, print.rmean = TRUE)
print(bug_lifes_w_NA.fit_dir, print.rmean = TRUE, scale=365.24, rmean=2897)
print(bug_lifes_w_NA.fit_cat, print.rmean = TRUE, scale=365.24, rmean=2897)
