#!/bin/sh

VER=linux-2.6.33
#VER=linux-3.0

if [ "$1" = "create" ] ; then

echo "CREATE TABLE tmp_compile_x386 ( \
    file_id integer NOT NULL, \
    file_name character varying(256) NOT NULL \
);"
fi

#
if [ "$1" = "dirlist" ] ; then

    for f in compile_defconfig compile_allyesconfig compile_allmodconfig ; do

	if [ -f $f ]; then
	    grep " CC .*\.o"  $f | grep -v "\.mod\.o" | \
		sed -e 's|\[M\]|   |' -e 's|  CC  *||' | \
		cut -f1 |  sed 's|\.o\r$|.c|'  | sort -u > $f.dirlist

    #Fix minor variations...
	    sed -i -e 's|arch/x86/oprofile/\.\./\.\./\.\./||' \
		-e 's|arch/x86/kvm/\.\./\.\./\.\./||' $f.dirlist
	else
	    echo "$f does not exist"
	fi
    done
fi
#
CLEAN=0

if [ "$1" = "defconfig" ]; then

for f in `grep -v "^$" compile_defconfig.dirlist | grep -v "\.S^"`; do
	echo "INSERT INTO tmp_compile_x386 VALUES (get_file('$VER', '$f'), '$f');"
done

echo "UPDATE files SET def_compiled = TRUE FROM tmp_compile_x386 WHERE files.file_id = tmp_compile_x386.file_id;";
CLEAN=1

#######################################################################################################

elif [ "$1" = "allyesconfig" ]; then

for f in `grep -v "^$" compile_allyesconfig.dirlist | grep -v "\.S^"`; do
	echo "INSERT INTO tmp_compile_x386 VALUES (get_file('$VER', '$f'), '$f');"
done

echo "UPDATE files SET allyes_compiled = TRUE FROM tmp_compile_x386 WHERE files.file_id = tmp_compile_x386.file_id;";
CLEAN=1

#######################################################################################################

elif [ "$1" = "allmodconfig" ]; then

for f in `grep -v "^$" compile_allmodconfig.dirlist | grep -v "\.S^"`; do
	echo "INSERT INTO tmp_compile_x386 VALUES (get_file('$VER', '$f'), '$f');"
done

echo "UPDATE files SET allmod_compiled = TRUE FROM tmp_compile_x386 WHERE files.file_id = tmp_compile_x386.file_id;";
CLEAN=1

fi

#######################################################################################################

if [ "$CLEAN" = "1" ]; then
    echo "TRUNCATE tmp_compile_x386;"
fi
